package modelo;
/*
 * 
 * 		---------------------------------------------------
 * 					Juego Pumba
 * 
 * 			Autor: Alejandro Raposo Lpez
 * 		--------------------------------------------------
 * 
 */

import java.util.List;
import java.util.LinkedList;
import java.util.Random;


public class Baraja {
	
	private List<Carta> baraja;
	
	public Baraja(boolean vacia){
		baraja = new LinkedList<Carta>();
		
		if(vacia==false){
			for(int i=0;i<13;i++){
				baraja.add(new Carta(i+1,'o'));
				baraja.add(new Carta(i+1,'c'));
				baraja.add(new Carta(i+1,'e'));
				baraja.add(new Carta(i+1,'b'));
			}
		}
	}


	public void barajar(){
		List<Carta> nbar = new LinkedList<Carta>();
		Random rnd = new Random();
		int pos;
		
		
		while(!baraja.isEmpty()){
			pos=Math.abs(rnd.nextInt())%baraja.size();
			nbar.add(baraja.remove(pos));
		}
		baraja=nbar;
	}
	
	//Elimina todas las cartas
	public void clear(){
		baraja.clear();
	}
	
	public String toString(){
		String s=new String();
		if(baraja.size()==0)
			return s;
		
		for(int i=0;i<baraja.size()-1;i++)
			s+=(baraja.get(i).toString())+";";
		
		return (s+(baraja.get(baraja.size()-1).toString()));
	}
	
	//Ultima carta insertada (al final)
	public Carta top(){
			return baraja.get(baraja.size()-1);
	}
	
	//Añade una carta (al final)
	public void add(Carta c){
		baraja.add(c);
	}
	
	//Añade todas las cartas de la Baraja bar a la actual
	public void addAll(Baraja bar){
		for(int i=0;i<bar.size();i++)
			this.add(bar.get(i));
	}
	
	//Elimina la primera carta (principio)
	public Carta remove(){
		return baraja.remove(0);
	}
	
	//Elimina las n primeras cartas
	public Baraja remove(int n){
		Baraja bar = new Baraja(true);
		for(int i=0;i<n;i++){
			bar.add(this.remove());
		}
		return bar;
	}
	
	
	//Elimina y devuelve la carta c, si existe, null en otro caso
	public Carta remove(Carta c){
		Carta dev = null;
		if(c!=null){
			Carta caux=null;
			boolean enc=false;
			int i=0;
			int siz = this.size();
			while(!enc && i<siz){
				caux=this.get(i);
				if(caux.equals(c)){
					enc=true;
					dev =caux;
					baraja.remove(caux);
				}
				i++;
			}
		}
		return dev;
	}
	
	//Tamaño de la baraja (numero actual de cartas)
	public int size(){
		return baraja.size();
	}
	
	//Devuelve la carta i-esima
	public Carta get(int i){
		return baraja.get(i);
	}
}
